unit SpriteHandlers;

interface

	uses
{$IFC UNDEFINED THINK_PASCAL}
		Types, QuickDraw, Fonts, Events, Packages, Menus, Dialogs, Windows,{}
		OSUtils, ToolUtils, OSEvents, 
{$ENDC}
		QDOffScreen, SpriteStructure, SpriteTools;

	procedure MoveSprite (theSprite: SpritePtr);
	procedure HitSprite (theSprite: SpritePtr; anotherSprite: SpritePtr);
	procedure InitSprites;

implementation


(*** Custom handlers - application dependent ***)

{Edit this as necessary. It should always include the following three routines:}

{MoveSprite: move the sprite}

{HitSprite: handle collisions between two sprites}

{InitSprites: Load all faces and create initial sprites}

	var
		firstFace, secondFace, thirdFace: GrafPtr;

	procedure MoveSprite (theSprite: SpritePtr);
	begin
		theSprite^.speed.v := theSprite^.speed.v + 1;
		theSprite^.fixedPointPosition.h := theSprite^.fixedPointPosition.h + theSprite^.speed.h;
		theSprite^.fixedPointPosition.v := theSprite^.fixedPointPosition.v + theSprite^.speed.v;
		theSprite^.position.h := BSR(theSprite^.fixedPointPosition.h, 4);
		theSprite^.position.v := BSR(theSprite^.fixedPointPosition.v, 4);
		if KeepOnScreenFixed(theSprite) then
			;
	end; (*MoveSprite*)


	procedure HitSprite (theSprite: SpritePtr; anotherSprite: SpritePtr);
	begin
	end; (*HitSprite*)

	procedure InitSprites;
		var
			theSprite: SpritePtr;
	begin
(*Load all pictures*)
		firstFace := LoadFaceFromCicn(128);			(*cicn resource #128.*)
		secondFace := LoadFaceFromCicn(129);			(*cicn resource #129.*)
		thirdFace := LoadFaceFromCicn(130);			(*cicn resource #130.*)

(*Create sprites*)
		theSprite := NewSprite;
		theSprite^.face := firstFace;
		SetPt(theSprite^.fixedPointPosition, BSL(100, 4), BSL(100, 4));
		SetPt(theSprite^.speed, 1, 16);

		theSprite := NewSprite;
		theSprite^.face := secondFace;
		SetPt(theSprite^.fixedPointPosition, BSL(50, 4), BSL(50, 4));
		SetPt(theSprite^.speed, 16, 1);

		theSprite := NewSprite;
		theSprite^.face := thirdFace;
		SetPt(theSprite^.fixedPointPosition, BSL(150, 4), BSL(150, 4));
		SetPt(theSprite^.speed, Rand(7) - 3, Rand(7) - 3);
	end; (*InitSprites*)

end.